Index: issm/trunk-jpl/src/c/classes/objects/Constraints/Constraints.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Constraints/Constraints.cpp	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Constraints/Constraints.cpp	(revision 14996)
@@ -0,0 +1,41 @@
+/*
+ * \file Constraints.cpp
+ * \brief: Implementation of Constraints class, derived from DataSet class.
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Constraints.h"
+#include "../../../shared/shared.h"
+#include "../../../toolkits/toolkits.h"
+
+using namespace std;
+/*}}}*/
+
+
+/*Numerics: */
+/*FUNCTION Constraints::NumberOfConstraints{{{*/
+int Constraints::NumberOfConstraints(void){
+
+	int localconstraints;
+	int numberofconstraints;
+
+	/*Get number of local constraints*/
+	localconstraints=this->Size();
+
+	/*figure out total number of constraints combining all the cpus (no clones here)*/
+	#ifdef _HAVE_MPI_
+		MPI_Reduce(&localconstraints,&numberofconstraints,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+		MPI_Bcast(&numberofconstraints,1,MPI_INT,0,IssmComm::GetComm());
+	#else
+		numberofconstraints=localconstraints;
+	#endif
+
+	return numberofconstraints;
+}
+/*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/Constraints/Constraints.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Constraints/Constraints.h	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Constraints/Constraints.h	(revision 14996)
@@ -0,0 +1,36 @@
+#ifndef _CONTAINER_CONSTRAINTS_H_
+#define  _CONTAINER_CONSTRAINTS_H_
+
+/*forward declarations */
+#include "../DataSet.h"
+#include "../../../shared/shared.h"
+
+/*! \brief Declaration of Constraints class. 
+ *
+ * Declaration of Constraints class for handling Single Point Constraints (SPCs).
+ * Constraints are vector lists (Containers) of Constraint objects.
+ */ 
+class Constraints: public DataSet{
+
+	public:
+
+		/*Object constructors and destructor*/
+		/*FUNCTION Constraints::Constraints(){{{*/
+		Constraints(){
+			enum_type=ConstraintsEnum;
+			return;
+		}
+		/*}}}*/
+		/*FUNCTION Constraints::~Constraints(){{{*/
+		~Constraints(){
+			return;
+		}
+		/*}}}*/
+
+
+		/*numerics*/
+		int   NumberOfConstraints(void);
+
+};
+
+#endif //ifndef _CONSTRAINTS_H_
Index: issm/trunk-jpl/src/c/classes/objects/Constraints/SpcDynamic.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Constraints/SpcDynamic.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Constraints/SpcDynamic.cpp	(revision 14996)
@@ -13,5 +13,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/Enum/Enum.h"
-#include "../../../Container/Container.h"
 #include "../objects.h"
 
Index: issm/trunk-jpl/src/c/classes/objects/Constraints/SpcStatic.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Constraints/SpcStatic.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Constraints/SpcStatic.cpp	(revision 14996)
@@ -13,5 +13,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/Enum/Enum.h"
-#include "../../../Container/Container.h"
 #include "../objects.h"
 
Index: issm/trunk-jpl/src/c/classes/objects/Constraints/SpcTransient.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Constraints/SpcTransient.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Constraints/SpcTransient.cpp	(revision 14996)
@@ -13,5 +13,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/Enum/Enum.h"
-#include "../../../Container/Container.h"
 #include "../objects.h"
 
Index: issm/trunk-jpl/src/c/classes/objects/DataSet.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/DataSet.cpp	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/DataSet.cpp	(revision 14996)
@@ -0,0 +1,284 @@
+/*
+ * \file DataSet.cpp
+ * \brief: Implementation of DataSet class
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <cstring>
+#include <vector>
+#include <functional>
+#include <algorithm>
+#include <iostream>
+
+#include "./DataSet.h"
+#include "../../shared/shared.h"
+
+using namespace std;
+/*}}}*/
+
+/*Constructors/Destructors*/
+/*FUNCTION DataSet::DataSet(){{{*/
+DataSet::DataSet(){
+
+	sorted=0;
+	sorted_ids=NULL;
+	id_offsets=NULL;
+
+}
+/*}}}*/
+/*FUNCTION DataSet::DataSet(int dataset_enum){{{*/
+DataSet::DataSet(int dataset_enum){
+	enum_type=dataset_enum;
+
+	sorted=0;
+	sorted_ids=NULL;
+	id_offsets=NULL;
+
+}
+/*}}}*/
+/*FUNCTION DataSet::Copy{{{*/
+DataSet*   DataSet::Copy(void){
+
+	vector<Object*>::iterator object;
+	Object* object_copy=NULL;
+
+	DataSet* copy=new DataSet(enum_type);
+
+	copy->sorted=sorted;
+	copy->presorted=presorted;
+	if(sorted_ids){
+		copy->sorted_ids=xNew<int>(objects.size());
+		xMemCpy<int>(copy->sorted_ids,sorted_ids,objects.size());
+	}
+	if(id_offsets){
+		copy->id_offsets=xNew<int>(objects.size());
+		xMemCpy<int>(copy->id_offsets,id_offsets,objects.size());
+	}
+
+	/*Now we need to deep copy the objects: */
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		/*Call echo on object: */
+		object_copy = (*object)->copy();
+		copy->AddObject(object_copy);
+	}
+	return copy;
+}
+/*}}}*/
+/*FUNCTION DataSet::~DataSet{{{*/
+DataSet::~DataSet(){
+	clear();
+	xDelete<int>(sorted_ids);
+	xDelete<int>(id_offsets);
+}
+/*}}}*/
+
+/*Specific methods*/
+/*FUNCTION DataSet::AddObject{{{*/
+int  DataSet::AddObject(Object* object){
+
+	_assert_(this);
+	objects.push_back(object);
+
+	return 1;
+}
+/*}}}*/
+/*FUNCTION DataSet::clear{{{*/
+void  DataSet::clear(){
+
+/*  use reverse_iterator for efficiency in matlab memory manager
+	(keeping old code in case it needs to revert back)  */
+
+//	vector<Object*>::iterator object;
+	vector<Object*>::reverse_iterator object;
+
+//	for ( object=objects.begin() ; object < objects.end(); object++ ){
+//		delete (*object);
+//	}
+	for ( object=objects.rbegin() ; object < objects.rend(); object++ ){
+		delete (*object);
+	}
+	objects.clear();
+}
+/*}}}*/
+/*FUNCTION DataSet::DeleteObject{{{*/
+int  DataSet::DeleteObject(Object* object){
+
+	vector<Object*>::iterator iterator;
+
+	if(object){
+		iterator = find(objects.begin(), objects.end(),object);
+		delete *iterator;
+		objects.erase(iterator);
+	}
+
+	return 1;
+
+}
+/*}}}*/
+/*FUNCTION DataSet::DeepEcho{{{*/
+void DataSet::DeepEcho(){
+
+	vector<Object*>::iterator object;
+
+	if(this==NULL)_error_("trying to echo a NULL dataset");
+
+	_pprintLine_("DataSet echo: " << objects.size() << " objects");
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		/*Call deep echo on object: */
+		(*object)->DeepEcho();
+
+	}
+}
+/*}}}*/
+/*FUNCTION DataSet::Echo{{{*/
+void DataSet::Echo(){
+
+	vector<Object*>::iterator object;
+
+	if(this==NULL)_error_("trying to echo a NULL dataset");
+
+	_pprintLine_("DataSet echo: " << objects.size() << " objects");
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		/*Call echo on object: */
+		(*object)->Echo();
+
+	}
+	return;
+}
+/*}}}*/
+/*FUNCTION DataSet::GetEnum(){{{*/
+int  DataSet::GetEnum(){
+	return enum_type;
+}
+/*}}}*/
+/*FUNCTION DataSet::GetEnum(int offset){{{*/
+int   DataSet::GetEnum(int offset){
+
+	return objects[offset]->ObjectEnum();
+
+}
+/*}}}*/
+/*FUNCTION DataSet::GetObjectByOffset{{{*/
+Object* DataSet::GetObjectByOffset(int offset){
+
+	/*Check index in debugging mode*/
+	_assert_(this!=NULL);
+	_assert_(offset>=0);
+	_assert_(offset<this->Size());
+
+	return objects[offset];
+
+}
+/*}}}*/
+/*FUNCTION DataSet::GetObjectById{{{*/
+Object* DataSet::GetObjectById(int* poffset,int eid){
+
+	int id_offset;
+	int offset;
+
+	_assert_(this);
+	if(!sorted)_error_("trying to binary search on a non-sorted dataset!");
+
+	/*Carry out a binary search on the sorted_ids: */
+	if(!binary_search(&id_offset,eid,sorted_ids,objects.size())){
+		_error_("could not find object with id " << eid << " in DataSet " << EnumToStringx(enum_type));
+	}
+
+	/*Convert  the id offset into sorted offset: */
+	offset=id_offsets[id_offset];
+
+	/*Assign output pointers if requested:*/
+	if(poffset)*poffset=offset;
+
+	/*Return object at offset position in objects :*/
+	return objects[offset];
+}
+/*}}}*/
+/*FUNCTION DataSet::Presort{{{*/
+void DataSet::Presort(){
+
+	/*vector of objects is already sorted, just allocate the sorted ids and their
+	 * offsets:*/
+	if(objects.size()){
+
+		/*Delete existing ids*/
+		xDelete<int>(sorted_ids);
+		xDelete<int>(id_offsets);
+
+		/*Allocate new ids*/
+		sorted_ids=xNew<int>(objects.size());
+		id_offsets=xNew<int>(objects.size());
+
+		/*Build id_offsets and sorted_ids*/
+		for(int i=0;i<objects.size();i++){
+			id_offsets[i]=i;
+			sorted_ids[i]=objects[i]->Id();
+		}
+	}
+
+	/*set sorted flag: */
+	sorted=1;
+}
+/*}}}*/
+/*FUNCTION DataSet::Size{{{*/
+int  DataSet::Size(void){
+	_assert_(this!=NULL);
+
+	return objects.size();
+}
+/*}}}*/
+/*FUNCTION DataSet::Sort{{{*/
+void DataSet::Sort(){
+
+	/*Only sort if we are not already sorted: */
+	if(!sorted){
+		_error_("not implemented yet!");
+	}
+}
+/*}}}*/
+
+/*Routines that relate to datasets, but which are not methods: */
+int ExpWrite(DataSet* contours,char* domainname){/*{{{*/
+
+	/*I/O: */
+	FILE* fid=NULL;
+	Contour<double>* contour = NULL;
+
+	/*open domain outline file for writing: */
+	if((fid=fopen(domainname,"w"))==NULL) _error_("could not open domain file " << domainname); 
+
+	for(int counter=0;counter<contours->Size();counter++){
+		contour=(Contour<double>*)contours->GetObjectByOffset(counter);
+
+		/*Write header: */
+		fprintf(fid,"## Name:%s\n",domainname);
+		fprintf(fid,"## Icon:0\n");
+		fprintf(fid,"# Points Count	Value\n");
+		fprintf(fid,"%u %s\n",contour->nods  ,"1.");
+		fprintf(fid,"# X pos	Y pos\n");
+
+		/*Write vertices: */
+		for(int i=0;i<contour->nods;i++){
+			fprintf(fid,"%lf\t%lf\n",contour->x[i],contour->y[i]);
+		}
+
+		/*Write blank line: */
+		if(counter<contours->Size()-1) fprintf(fid,"\n");
+	}
+
+	/*close Exp file: */
+	fclose(fid);
+
+	return 1;
+}/*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/DataSet.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/DataSet.h	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/DataSet.h	(revision 14996)
@@ -0,0 +1,87 @@
+#ifndef _CONTAINER_DATASET_H_
+#define _CONTAINER_DATASET_H_
+
+#include <vector>
+#include <cstring>
+#include "./Contour.h"
+#include "../../shared/Exp/exp.h"
+
+/*forward declarations */
+class Object;
+class Results;
+
+/*! \brief Declaration of DataSet class
+ *
+ * Declaration of DataSet class.  A DataSet is a Container of Objects.
+ */
+class DataSet{
+
+	public: 
+
+		/*internals: */
+		std::vector<Object*> objects;
+
+		/*type of dataset: */
+		int             enum_type;
+
+		/*sorting: */
+		int             sorted;
+		int             presorted;
+		int*            sorted_ids;
+		int*            id_offsets;
+
+		/*constructors, destructors*/
+		DataSet();
+		DataSet(int enum_type);
+		~DataSet();
+
+		/*management*/
+		int      GetEnum();
+		int      GetEnum(int offset);
+		void     Echo();
+		void     DeepEcho();
+		int      AddObject(Object *object);
+		int      DeleteObject(int id);
+		int      Size();
+		void     clear();
+		Object  *GetObjectByOffset(int  offset);
+		Object  *GetObjectById(int *poffset,int eid);
+		void     Presort();
+		void     Sort();
+		DataSet *Copy(void);
+		int      DeleteObject(Object *object);
+		Results *SpawnTriaResults(int *indices);
+
+};
+
+/*Methods that relate to datasets: */
+int ExpWrite(DataSet* contours,char* domainname);
+template <class doubletype> DataSet* ExpRead(char* domainname){ /*{{{*/
+
+	/*intermediary: */
+	int                  nprof;
+	int                 *profnvertices = NULL;
+	doubletype         **pprofx        = NULL;
+	doubletype         **pprofy        = NULL;
+
+	/*output: */
+	DataSet *domain = NULL;
+
+	/*If domainname is an empty string, return empty dataset*/
+	if (strcmp(domainname,"")==0){
+		nprof=0;
+	}
+	else{
+		ExpRead(&nprof,&profnvertices,&pprofx, &pprofy, NULL,domainname);
+	}
+
+	/*now create dataset of contours: */
+	domain=new DataSet(0);
+
+	for(int i=0;i<nprof;i++){
+		domain->AddObject(new Contour<doubletype>(i,profnvertices[i],pprofx[i],pprofy[i],1));
+	}
+	return domain;
+} /*}}}*/
+
+#endif
Index: issm/trunk-jpl/src/c/classes/objects/DependentObject.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/DependentObject.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/DependentObject.cpp	(revision 14996)
@@ -14,5 +14,4 @@
 #include "../../shared/Enum/Enum.h"
 #include "../../shared/shared.h"
-#include "../../Container/Container.h"
 
 /*DependentObject constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/ElementResults/BoolElementResult.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/ElementResults/BoolElementResult.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/ElementResults/BoolElementResult.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 
 /*BoolElementResult constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/ElementResults/DoubleElementResult.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/ElementResults/DoubleElementResult.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/ElementResults/DoubleElementResult.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 
 /*DoubleElementResult constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/ElementResults/PentaP1ElementResult.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/ElementResults/PentaP1ElementResult.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/ElementResults/PentaP1ElementResult.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 
 /*PentaP1ElementResult constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/ElementResults/TriaP1ElementResult.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/ElementResults/TriaP1ElementResult.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/ElementResults/TriaP1ElementResult.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 
 /*TriaP1ElementResult constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/Elements/Element.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/Element.h	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/Element.h	(revision 14996)
@@ -16,4 +16,10 @@
 class Parameters;
 class Patch;
+class Elements;
+class Loads;
+class Node;
+class Nodes;
+class Vertices;
+class Materials;
 template <class doublematrix> class Matrix;
 template <class doubletype> class Vector;
Index: issm/trunk-jpl/src/c/classes/objects/Elements/Elements.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/Elements.cpp	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/Elements.cpp	(revision 14996)
@@ -0,0 +1,343 @@
+/*
+ * \file Elements.cpp
+ * \brief: Implementation of Elements class, derived from DataSet class
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Element.h"
+#include "./Elements.h"
+#include "../Params/Parameters.h"
+#include "../ExternalResults/Results.h"
+#include "../ExternalResults/GenericExternalResult.h"
+#include "../../toolkits/toolkitobjects.h"
+#include "../../Patch.h"
+#include "../../../shared/shared.h"
+
+using namespace std;
+/*}}}*/
+
+/*Object constructors and destructor*/
+/*FUNCTION Elements::Elements(){{{*/
+Elements::Elements(){
+	enum_type=MeshElementsEnum;
+	return;
+}
+/*}}}*/
+/*FUNCTION Elements::~Elements(){{{*/
+Elements::~Elements(){
+	return;
+}
+/*}}}*/
+
+/*Object management*/
+/*FUNCTION Elements::Configure{{{*/
+void Elements::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Element* element=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		element=dynamic_cast<Element*>((*object));
+		element->Configure(elements,loads,nodes,vertices,materials,parameters);
+
+	}
+
+}
+/*}}}*/
+/*FUNCTION Elements::ProcessResultsUnits{{{*/
+void Elements::ProcessResultsUnits(void){
+
+	//Process results to be output in the correct units
+	for(int i=0;i<this->Size();i++){
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		element->ProcessResultsUnits();
+	}
+}
+/*}}}*/
+/*FUNCTION Elements::DeleteResults{{{*/
+void Elements::DeleteResults(void){
+
+	for (int i=0;i<this->Size();i++){
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		element->DeleteResults();
+	}
+}
+/*}}}*/
+/*FUNCTION Elements::ResultsToPatch{{{*/
+Patch* Elements::ResultsToPatch(void){ 
+
+	/*output: */
+	Patch* patch=NULL;
+
+	/*intermediary: */
+	int i;
+	int count;
+	int numrows;
+	int numvertices;
+	int numnodes;
+	int max_numvertices;
+	int max_numnodes;
+	int element_numvertices;
+	int element_numrows;
+	int element_numnodes;
+
+	/*We are going to extract from the results within the elements, the desired results , and create a table 
+	 * of patch information, that will hold, for each element that computed the result that 
+	 * we desire, the enum_type of the result, the step and time, the id of the element, the interpolation type, the vertices ids, and the values 
+	 * at the nodes (could be different from the vertices). This will be used for visualization purposes. 
+	 * For example, we could build the following patch table, for velocities: 
+	 * 
+	 1. on a Beam element, Vx, at step 1, time .5, element id 1, interpolation type P0 (constant), vertices ids 1 and 2, one constant value 4.5
+	 VxEnum 1  .5  1 P0  1 2       4.5 NaN  NaN
+	 2. on a Tria element, Vz, at step 2, time .8, element id 2, interpolation type P1 (linear), vertices ids 1 3 and 4, with values at 3 nodes 4.5, 3.2, 2.5
+	 VzEnum 2  .8  2 P1  1 3 4     4.5 3.2  2.5
+	 * ... etc ...
+	 *
+	 * So what do we need to build the table: the maximum number of vertices included in the table, 
+	 * and the maximum number of nodal values, as well as the number of rows. Once we have that, 
+	 * we ask the elements to fill their own row in the table, by looping on the elememnts. 
+	 *
+	 * We will use the Patch object, which will store all of the information needed, and will be able 
+	 * to output itself to disk on its own. See object/Patch.h for format of this object.*/
+
+	/*First, determine maximum number of vertices, nodes, and number of results: */
+	numrows=0;
+	numvertices=0;
+	numnodes=0;
+
+	for(i=0;i<this->Size();i++){
+
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		element->PatchSize(&element_numrows,&element_numvertices,&element_numnodes);
+
+		numrows+=element_numrows;
+		if(element_numvertices>numvertices)numvertices=element_numvertices;
+		if(element_numnodes>numnodes)numnodes=element_numnodes;
+	}
+
+	/*Synchronize across cluster, so as to not end up with different sizes for each patch on each cpu: */
+	#ifdef _HAVE_MPI_
+	MPI_Reduce (&numvertices,&max_numvertices,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&max_numvertices,1,MPI_INT,0,IssmComm::GetComm());
+	numvertices=max_numvertices;
+
+	MPI_Reduce (&numnodes,&max_numnodes,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&max_numnodes,1,MPI_INT,0,IssmComm::GetComm());
+	numnodes=max_numnodes;
+	#endif
+
+	/*Ok, initialize Patch object: */
+	patch=new Patch(numrows,numvertices,numnodes);
+
+	/*Now, go through elements, and fill the Patch object: */
+	count=0;
+	for(i=0;i<this->Size();i++){
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		element->PatchFill(&count,patch);
+	}
+
+	return patch;
+}
+/*}}}*/
+/*FUNCTION Elements::SetCurrentConfiguration{{{*/
+void Elements::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Element* element=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		element=dynamic_cast<Element*>((*object));
+		element->SetCurrentConfiguration(elements,loads,nodes,materials,parameters);
+
+	}
+
+}
+/*}}}*/
+/*FUNCTION Elements::ToResults{{{*/
+void Elements::ToResults(Results* results,Parameters* parameters){
+
+	int my_rank;
+	int num_procs;
+
+	Patch               *patch              = NULL;
+	int                 *resultsenums       = NULL;
+	int                 *resultssizes       = NULL;
+	int                 *resultssteps       = NULL;
+	IssmDouble          *resultstimes       = NULL;
+	IssmDouble          *vector_serial      = NULL;
+	Vector<IssmDouble> *vector = NULL;
+	bool                io_gather;
+	bool                results_as_patches;
+	int                 numberofvertices     ,numberofelements;
+	int                 numberofresults      ,vectorsize;
+	int                 rank;
+	int                 minrank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+	num_procs=IssmComm::GetSize();
+
+	/*Recover parameters: */
+	parameters->FindParam(&io_gather,SettingsIoGatherEnum);
+	parameters->FindParam(&results_as_patches,SettingsResultsAsPatchesEnum);
+	parameters->FindParam(&numberofvertices,MeshNumberofverticesEnum);
+	parameters->FindParam(&numberofelements,MeshNumberofelementsEnum);
+
+	if(!results_as_patches){
+		/*No patch here, we prepare vectors*/
+
+		/*Get rank of first cpu that has results*/
+		#ifdef _HAVE_MPI_
+		if(this->Size()) rank=my_rank;
+		else rank=num_procs;
+		MPI_Allreduce (&rank,&minrank,1,MPI_INT,MPI_MIN,IssmComm::GetComm());
+		#else
+		minrank=my_rank;
+		#endif
+
+		/*see what the first element of this partition has in stock (this is common to all partitions)*/
+		if(my_rank==minrank){
+			if(this->Size()==0) _error_("Cannot write results because there is no element??");
+			Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(0));
+			element->ListResultsInfo(&resultsenums,&resultssizes,&resultstimes,&resultssteps,&numberofresults);
+		}
+		#ifdef _HAVE_MPI_
+		MPI_Bcast(&numberofresults,1,MPI_DOUBLE,minrank,IssmComm::GetComm());
+		#endif
+
+		/*Get out if there is no results. Otherwise broadcast info*/
+		if(!numberofresults) return;
+		#ifdef _HAVE_MPI_
+		if(my_rank!=minrank){
+			resultsenums=xNew<int>(numberofresults);
+			resultssizes=xNew<int>(numberofresults);
+			resultstimes=xNew<IssmDouble>(numberofresults);
+			resultssteps=xNew<int>(numberofresults);
+		}
+		MPI_Bcast(resultsenums,numberofresults,MPI_INT,minrank,IssmComm::GetComm());
+		MPI_Bcast(resultssizes,numberofresults,MPI_INT,minrank,IssmComm::GetComm());
+		MPI_Bcast(resultstimes,numberofresults,MPI_DOUBLE,minrank,IssmComm::GetComm());
+		MPI_Bcast(resultssteps,numberofresults,MPI_INT,minrank,IssmComm::GetComm());
+		#endif
+
+		/*Loop over all results and get nodal vector*/
+		for(int i=0;i<numberofresults;i++){
+
+			/*Get vector for result number i*/
+			if(resultssizes[i]==P1Enum)      vectorsize=numberofvertices;
+			else if(resultssizes[i]==P0Enum) vectorsize=numberofelements;
+			else _error_("Unkown result size: " << EnumToStringx(resultssizes[i]));
+			vector=new Vector<IssmDouble>(vectorsize);
+
+			for(int j=0;j<this->Size();j++){
+				Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(j));
+				element->GetVectorFromResults(vector,i,resultsenums[i],resultssizes[i]);
+			}
+			vector->Assemble();
+
+			/*Serialize and add to results*/
+			vector_serial=vector->ToMPISerial();
+			if(my_rank==0){
+				/*No need to add this vector for all cpus*/
+				#ifdef _HAVE_ADOLC_
+				IssmPDouble* vector_serial_passive=xNew<IssmPDouble>(vectorsize);
+				for(int k=0;k<vectorsize;k++)vector_serial_passive[k]=reCast<IssmPDouble>(vector_serial[k]);
+				results->AddObject(new GenericExternalResult<double*>(results->Size()+1,resultsenums[i],vector_serial_passive,vectorsize,1,resultssteps[i],resultstimes[i]));
+				xDelete<IssmPDouble>(vector_serial_passive);
+				#else
+				results->AddObject(new GenericExternalResult<double*>(results->Size()+1,resultsenums[i],vector_serial,vectorsize,1,resultssteps[i],resultstimes[i]));
+				#endif
+			}
+
+			/*clean up*/
+			delete vector;
+			xDelete<IssmDouble>(vector_serial);
+		}
+	}
+	else{
+		/*create patch object out of all results in this dataset: */
+		patch=this->ResultsToPatch();
+
+		/*Gather onto master cpu 0, if needed: */
+		if(io_gather)patch->Gather();
+
+		/*create result object and add to results dataset:*/
+		if (patch->maxvertices && patch->maxnodes){
+			results->AddObject(new GenericExternalResult<int>(results->Size()+1,PatchVerticesEnum,patch->maxvertices,1,0));
+			results->AddObject(new GenericExternalResult<int>(results->Size()+1,PatchNodesEnum,   patch->maxnodes,1,0));
+			#ifdef _HAVE_ADOLC_
+			IssmPDouble* values_passive=xNew<IssmPDouble>(patch->numrows*patch->numcols);
+			for(int k=0;k<(patch->numrows*patch->numcols);k++)values_passive[k]=reCast<IssmPDouble>(patch->values[k]);
+			results->AddObject(new GenericExternalResult<double*>(results->Size()+1,PatchEnum,  values_passive,patch->numrows,patch->numcols,1,0));
+			xDelete<IssmPDouble>(values_passive);
+			#else
+			results->AddObject(new GenericExternalResult<double*>(results->Size()+1,PatchEnum,  patch->values,patch->numrows,patch->numcols,1,0));
+			#endif
+		}
+	}
+
+	/*Free ressources:*/
+	xDelete<int>(resultsenums);
+	xDelete<int>(resultssizes);
+	xDelete<int>(resultssteps);
+	xDelete<IssmDouble>(resultstimes);
+	delete patch;
+}
+/*}}}*/
+/*FUNCTION Elements::MaxNumNodes{{{*/
+int Elements::MaxNumNodes(void){
+
+	int max=0;
+	int allmax;
+	int numnodes=0;
+
+	/*Now go through all elements, and get how many nodes they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		numnodes=element->GetNumberOfNodes();
+		if(numnodes>max)max=numnodes;
+	}
+
+	/*Grab max of all cpus: */
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	max=allmax;
+	#endif
+
+	return max;
+}
+/*}}}*/
+/*FUNCTION Elements::NumberOfElements{{{*/
+int Elements::NumberOfElements(void){
+
+	int local_nelem;
+	int numberofelements;
+
+	local_nelem=this->Size();
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce ( (void*)&local_nelem,(void*)&numberofelements,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
+	#else
+	numberofelements=local_nelem;
+	#endif
+
+	return numberofelements;
+}
+/*}}}*/
+/*FUNCTION Elements::InputCopy{{{*/
+void Elements::InputDuplicate(int input_enum,int output_enum){
+
+	for(int i=0;i<this->Size();i++){
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		element->InputDuplicate(input_enum,output_enum);
+	}
+}
+/*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/Elements/Elements.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/Elements.h	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/Elements.h	(revision 14996)
@@ -0,0 +1,38 @@
+#ifndef _CONTAINER_ELEMENTS_H_
+#define  _CONTAINER_ELEMENTS_H_
+
+/*forward declarations */
+#include "../DataSet.h"
+class Materials;
+class Parameters;
+class Vertices;
+class Loads;
+class Nodes;
+class Patch;
+
+/*! \brief Declaration of Elements class 
+ *
+ * Declaration of Elements class.  Elements are vector lists (Containers) of Element objects.
+ */ 
+class Elements: public DataSet{
+
+	public:
+
+		/*constructors, destructors*/
+		Elements();
+		~Elements();
+
+		/*numerics*/
+		void   Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void   DeleteResults(void);
+		int    MaxNumNodes(void);
+		void   ProcessResultsUnits(void);
+		void   SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void   ToResults(Results* results,Parameters* parameters);
+		Patch* ResultsToPatch(void);
+		int    NumberOfElements(void);
+		void   InputDuplicate(int input_enum,int output_enum);
+
+};
+
+#endif //ifndef _ELEMENTS_H_
Index: issm/trunk-jpl/src/c/classes/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/Penta.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/Penta.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../../classes.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Elements/PentaHook.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/PentaHook.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/PentaHook.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Elements/PentaRef.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/PentaRef.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/PentaRef.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Elements/Tria.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/Tria.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/Tria.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../../classes.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 #ifdef _HAVE_GIA_
 #include "../../../modules/GiaDeflectionCorex/GiaDeflectionCorex.h"
Index: issm/trunk-jpl/src/c/classes/objects/Elements/Tria.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Elements/Tria.h	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Elements/Tria.h	(revision 14996)
@@ -19,4 +19,5 @@
 class ElementMatrix;
 class ElementVector;
+class Vertex;
 
 #include "../../../shared/Exceptions/exceptions.h"
